



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>TCP详解——连接建立与断开</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">TCP详解——连接建立与断开</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 16:02:14 </span>
						</div>
										<div class="post-content">
											
		<p><strong>一、报文结构介绍</strong></p>
<p>　　在开始讲TCP连接过程时，还是先看看TCP报文的格式如图1所示。IP数据报此时由IP头部+TCP头部+TCP数据组成。不带选项的TCP头部是20字节长，而带选项的，TCP头部最长可达60字节。常见的选项包括最大的大小（MSS），时间戳（传输控制时使用）、窗口缩放（流量控制时使用）、选择性ACK（传输控制时使用）。我们来具体看下TCP头部字段如图2所示。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/987585/201711/987585-20171105181659857-1577625568.jpg" /></p>
<p><strong>图1 IP数据报中TCP封装</strong></p>
<p>　　图2所示的即是TCP头部的详细结构。源端口与目的端口和源IP及目的IP这四元组唯一标识每个TCP连接。序列号（Sequence Number）字段标识TCP的一端到另一端的数据流的第一个开始字节（例如发送端发送的数据总字节长度为1000字节，假定序列号从1开始，总的序列号是1-1000，TCP会给每个字节赋予一个序列号）。通过序列号来代表发送端到接收端的数据，接收端接收到数据后，即可通过确认号（ACK）来发送给发送端，让发送端知道数据已被接受。这个ACK号是由接收到的数据的序列号加1，代表接收端希望接收的下一个数据的序列号。（注：ACK是不占用序列号的，原因是接收端发送ACK给发送端后，发送端的ISN是等于此时接收到的ACK号）。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/987585/201711/987585-20171105182551123-1254221974.jpg" /></p>
<p><strong>图2 TCP头部结构</strong></p>
<p>　　头部长度的单位32bit，所以这也定义了TCP的长度最大为4*15=60字节。八个标志位中（CWR、ECE。。。等），这里先每个介绍，后面文章有用到时在另行介绍。我们来主要了解下ACK、SYN、FIN。ACK即确认，连接建立后一般都是启用状态。SYN用于初始化一个连接的同步序列号。当发送方已经结束数据的发送时，即发送FIN报文段给接收端。窗口大小在TCP流量控制中会重点讲解。</p>
<p><strong>二、TCP连接的建立与终止</strong></p>
<p><strong>　　</strong>如图3所示即为TCP连接建立与终止的过程图。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/987585/201711/987585-20171105185155482-1539539819.jpg" /></p>
<p><strong>图3 TCP连接的建立与终止</strong></p>
<p>TCP建立的三次握手：</p>
<p>　　1、发送端发送一个SYN报文段（SYN位被置位），SYN中包含TCP目的端口和发送端的初始序列号（图中ISN(c)），同时携带着TCP选项数据。</p>
<p>　　2、接收端收到发送端连接请求后，接收端发送自己SYN报文段（包含ISN(s)），同时对发送端的SYN进行确认，如前所述，接收端发送的ACK是ISN(c)+1。此时ACK位与SYN位都被置位。接收端发送SYN+ACK到发送端。</p>
<p>　　3、发送端接收到接收端的SYN+ACK数据后，对ISN(s)进行确认，发送ACK为ISN(s)+1的报文段给接收端。</p>
<p>TCP断开的四次握手：</p>
<p>　　1、TCP协议规定通过发送一个FIN段（FIN被置位）来发起关闭操作，图3中发送端发送FIN段给接收端，告知它数据已发送完毕，请求断开TCP连接。同时FIN报文段还包含着对最近收到的数据进行ACK。</p>
<p>　　2、接收端接收端FIN报文段后，对FIN进行确认，发送ACK=k+1给发送端。</p>
<p>　　3、接收端将连接关闭发送给上层应用程序，由应用程序发起连接关闭操作。此时接收端由被动关闭连接壮成主动，并发送FIN报文段给发送端。报文的序列号为L（这里也可看出上一步骤中发送ACK序列号也为L，因为ACK不占用序列号，所以这里的FIN的序列号也为L）。</p>
<p>　　4、发送端接收到FIN后，发送回ACK给接收端后，TCP连接终止。如果FIN丢失，发送FIN的那端需要重新发送FIN，知道接收到ACK为止。</p>
<p><strong>三：总结</strong></p>
<p><strong>　　</strong>如前所述，建立一个TCP连接需要3个报文段，而关闭TCP连接需要4个报文段。</p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jz5r48.html">weex append</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kpy639.html">iOS 中 ARC 项目 兼容 MRC</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ood5x8.html">Dubbo系列&lpar;2&rpar;&lowbar;RPC介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jg5n49.html">Java数据库&mdash;&mdash;ResultSet接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9povy7q.html">（spring-第19回【AOP基础篇】）基于AspectJ和Schema的AOP</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd72o0q.html">HTML实体对照表</a>
		</li>
						<li><a href="https://www.batexi.com/a/390z6m4q.html">Opencv显示图片并监听鼠标坐标</a>
		</li>
						<li><a href="https://www.batexi.com/a/m961p048.html">&lbrack;整&rsqb; JavaScript m选n组合算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4g5gq.html">Eclipse中Maven工程缺少Maven Dependencies</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmg0369.html">大数值基础、for与while循环的简单对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zlmoj9.html">修炼dp&lpar; 2 &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdkpgd9.html">Spring MVC 程序首页的设置 - 一号门-程序员的工作&comma;程序员的生活&lpar;java&comma;python&comma;delphi实战&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1n3rgq.html">Mysql中给有记录的表添加唯一索引</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgj6lm8.html">error lnk1158 无法运行rc&period;exe</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r51zw4q.html">POJ 3169 Layout 【差分约束】&plus;【spfa】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllk0ykq.html">OpenCV 学习笔记 07 支持向量机SVM（flag）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy3jln9.html">Linux命令 umask</a>
		</li>
						<li><a href="https://www.batexi.com/a/960l1739.html">Java笔试面试题整理第六波（修正版）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk4w618.html">搭建事务管理转账案例的环境（强调：简化开发，以后DAO可以继承JdbcDaoSupport类）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko25lrq.html">更改GeoServer的端口号</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93wjk5rq.html">Clear Linux 为脚本语言提供更高的性能</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj30k49.html">C&num;使用读写锁解决多线程并发写入文件时线程同步的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rd0gn9.html">HDU 4344-Mark the Rope-大数素因子分解</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gp1wmq.html">LOJ6053 简单的函数 【Min&lowbar;25筛】【埃拉托斯特尼筛】</a>
			</li>
						<li><a href="https://www.batexi.com/a/960mnvv9.html">HBase 清空表数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2d7e2q.html">Hard Life UVA - 1389（最大密度子图  输出点集）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllo341q.html">POI中不推荐的方法与其替代的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjme279.html">MT【286】最佳有理逼近</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdl74e9.html">测试工作常用SQL查询语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wje4wq.html">docker命令篇</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
